﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using TXTextControl.DocumentServer.Fields;

namespace tx_merge_richtext
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void mailMerge1_FieldMerged(object sender,
            TXTextControl.DocumentServer.MailMerge.FieldMergedEventArgs e)
        {
            if (((MergeField)e.MailMergeFieldAdapter).Name.StartsWith("richtext_")
                == false)
                return;

            byte[] data;

            using (TXTextControl.ServerTextControl tx =
                new TXTextControl.ServerTextControl())
            {
                tx.Create();            
                tx.Load(((MergeField)e.MailMergeFieldAdapter).Text,
                    TXTextControl.StringStreamType.HTMLFormat);
                tx.Save(out data, TXTextControl.BinaryStreamType.InternalUnicodeFormat);
            }

            e.MergedField = data;
        }

        private void mergeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            TXTextControl.LoadSettings ls = new TXTextControl.LoadSettings();
            ls.ApplicationFieldFormat = TXTextControl.ApplicationFieldFormat.MSWord;
            textControl1.Load("template.docx",
                TXTextControl.StreamType.WordprocessingML, ls);

            // create a dummy data source 
            DataTable dt = new DataTable();

            dt.Columns.Add("normal");
            dt.Columns.Add("richtext_description");

            dt.Rows.Add(new object[] { "Static text", "<span style='font-family: Segoe UI Light;'><b>Bold Text</b> Normal <i>Italic Text</i><br /><b>New line</b></span>" });
            dt.Rows.Add(new object[] { "More static text", "<span style='font-family: Segoe UI Light;'><ul><li>List Item 1</li><li><b>List Item 1<b></li><li>List Item 1</li></ul></span>" });

            // merge template 
            mailMerge1.Merge(dt, true);
        }

    }
}
